var gulp = require('gulp');
var concat = require('gulp-concat');
var uglify = require('gulp-uglify');
var rename = require('gulp-rename');
var bump = require('gulp-bump');
var git = require('gulp-git');

gulp.task('compress', function() {
  return gulp.src(['JsBarcode.js','barcodes/*.js'])
  .pipe(concat("JsBarcode.all.min.js"))
  .pipe(uglify())
  .pipe(gulp.dest('./'));
});

gulp.task('git-release', ['compress'], function(){
  var pkg = require('./package.json');
  var v = 'v' + pkg.version;
  var message = 'Release ' + v;

  return gulp.src(['./package.json', './bower.json', 'JsBarcode.all.min.js'])
    .pipe(git.commit(message))
    .pipe(git.tag(v, message))
    .pipe(git.push('origin', 'master', {args: " --tags"}, function (err) {
      if (err) throw err;
    }))
});

// Bump (increase) the version number
gulp.task('bump-patch', function(){
  return gulp.src(['./package.json', './bower.json'])
    .pipe(bump({type:'patch'}))
    .pipe(gulp.dest('./'));
});

gulp.task('bump-minor', function(){
  return gulp.src(['./package.json', './bower.json'])
    .pipe(bump({type:'minor'}))
    .pipe(gulp.dest('./'));
});

gulp.task('bump-major', function(){
  return gulp.src(['./package.json', './bower.json'])
    .pipe(bump({type:'major'}))
    .pipe(gulp.dest('./'));
});

gulp.task('npm', function (done) {
  require('child_process').spawn('npm', ['publish'], { stdio: 'inherit' })
    .on('close', done);
});

gulp.task('patch', ['bump-patch','git-release','npm']);
gulp.task('minor', ['bump-minor','git-release','npm']);
gulp.task('major', ['bump-major','git-release','npm']);
